searchNodes=[{"doc":"Create a device certificate without a NervesKey create This simulates certification creation if you don't have a NervesKey. While this doesn't make any sense if you're using NervesKeys, it can be handy in testing device certs that look like they're from NervesKeys. mix nerves_key.device create NAME --signer-cert &lt;CERT&gt; --signer-key &lt;KEY&gt; If --years-valid is unspecified, the new certificate will be valid for one year.","ref":"Mix.Tasks.NervesKey.Device.html","title":"Mix.Tasks.NervesKey.Device","type":"task"},{"doc":"","ref":"Mix.Tasks.NervesKey.Device.html#create/2","title":"Mix.Tasks.NervesKey.Device.create/2","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.NervesKey.Device.html#run/1","title":"Mix.Tasks.NervesKey.Device.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.NervesKey.Device.html#usage/0","title":"Mix.Tasks.NervesKey.Device.usage/0","type":"function"},{"doc":"Manages NervesKey signing keys create Create a new NervesKey signer certificate and private key pair. This creates a compressible X.509 certificate that can be stored in the ATECC508A's limited memory. mix nerves_key.signer create NAME --years-valid &lt;YEARS&gt; If --years-valid is unspecified, the new certificate will be valid for one year.","ref":"Mix.Tasks.NervesKey.Signer.html","title":"Mix.Tasks.NervesKey.Signer","type":"task"},{"doc":"","ref":"Mix.Tasks.NervesKey.Signer.html#create/2","title":"Mix.Tasks.NervesKey.Signer.create/2","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.NervesKey.Signer.html#run/1","title":"Mix.Tasks.NervesKey.Signer.run/1","type":"function"},{"doc":"","ref":"Mix.Tasks.NervesKey.Signer.html#usage/0","title":"Mix.Tasks.NervesKey.Signer.usage/0","type":"function"},{"doc":"This is a high level interface to provisioning and using the NervesKey or any ATECC508A/608A that can be configured similarly.","ref":"NervesKey.html","title":"NervesKey","type":"module"},{"doc":"Clear out the auxiliary certificates This function overwrites the auxiliary certificate slots with","ref":"NervesKey.html#clear_aux_certificates/1","title":"NervesKey.clear_aux_certificates/1","type":"function"},{"doc":"Create a signing key pair This returns a tuple that contains a new signer certificate and private key. It is compatible with the ATECC508A certificate compression. Options: :years_valid - how many years this key is valid for","ref":"NervesKey.html#create_signing_key_pair/1","title":"NervesKey.create_signing_key_pair/1","type":"function"},{"doc":"Return default provisioning info for a NervesKey This function is used for pre-programmed NervesKey devices. The serial number is a Base32-encoded version of the ATECC508A/608A's globally unique serial number. No additional care is needed to keep the number unique.","ref":"NervesKey.html#default_info/1","title":"NervesKey.default_info/1","type":"function"},{"doc":"Detect if a NervesKey is available on the transport","ref":"NervesKey.html#detected?/1","title":"NervesKey.detected?/1","type":"function"},{"doc":"Read the device certificate from the slot The device must be programmed for this to work.","ref":"NervesKey.html#device_cert/2","title":"NervesKey.device_cert/2","type":"function"},{"doc":"Return the settings block as a binary","ref":"NervesKey.html#get_raw_settings/1","title":"NervesKey.get_raw_settings/1","type":"function"},{"doc":"Return all of the setting stored in the NervesKey as a map","ref":"NervesKey.html#get_settings/1","title":"NervesKey.get_settings/1","type":"function"},{"doc":"Check whether the auxiliary certificates were programmed","ref":"NervesKey.html#has_aux_certificates?/1","title":"NervesKey.has_aux_certificates?/1","type":"function"},{"doc":"Read the manufacturer's serial number","ref":"NervesKey.html#manufacturer_sn/1","title":"NervesKey.manufacturer_sn/1","type":"function"},{"doc":"Provision a NervesKey in one step. See the README.md for how to use this. This function locks the ATECC508A down, so you'll want to be sure what you pass it is correct. This function does it all. It requires the signer's private key so handle that with care. Alternatively, please consider sending a PR for supporting off-device signatures so that HSMs can be used.","ref":"NervesKey.html#provision/4","title":"NervesKey.provision/4","type":"function"},{"doc":"Provision the auxiliary device/signer certificates on a NervesKey. This function creates and saves the auxiliary certificates. These are only needed if the ones written by provision/4 are not usable. They are not used unless explicitly requested. See the README.md for details. You may call this function multiple times after the ATECC508A has been provisioned.","ref":"NervesKey.html#provision_aux_certificates/3","title":"NervesKey.provision_aux_certificates/3","type":"function"},{"doc":"Check whether the NervesKey has been provisioned","ref":"NervesKey.html#provisioned?/1","title":"NervesKey.provisioned?/1","type":"function"},{"doc":"Store raw settings on the Nerves Key This overwrites all of the settings and should be used with care since there's no protection against race conditions with other users of this API.","ref":"NervesKey.html#put_raw_settings/2","title":"NervesKey.put_raw_settings/2","type":"function"},{"doc":"Store settings on the NervesKey This overwrites all of the settings that are currently on the key and should be used with care since there's no protection against a race condition with other NervesKey users.","ref":"NervesKey.html#put_settings/2","title":"NervesKey.put_settings/2","type":"function"},{"doc":"Sign a SHA256 digest","ref":"NervesKey.html#sign_digest/2","title":"NervesKey.sign_digest/2","type":"function"},{"doc":"Read the signer certificate from the slot","ref":"NervesKey.html#signer_cert/2","title":"NervesKey.signer_cert/2","type":"function"},{"doc":"Return ssl_opts for using the NervesKey Pass an engine and optionally which certificate that you'd like to use.","ref":"NervesKey.html#ssl_opts/2","title":"NervesKey.ssl_opts/2","type":"function"},{"doc":"Which device/signer certificate pair to use","ref":"NervesKey.html#t:certificate_pair/0","title":"NervesKey.certificate_pair/0","type":"type"},{"doc":"This is a high level interface to provisioning and using the NervesKey or any ATECC508A/608A that can be configured similarly.","ref":"NervesKey.Config.html","title":"NervesKey.Config","type":"module"},{"doc":"Check if the chip's configuration is compatible with the NervesKey. This only checks what's important for the NervesKey.","ref":"NervesKey.Config.html#config_compatible?/1","title":"NervesKey.Config.config_compatible?/1","type":"function"},{"doc":"Configure an ATECC508A or ATECC608A as a NervesKey. This can only be called once. Subsequent calls will fail.","ref":"NervesKey.Config.html#configure/1","title":"NervesKey.Config.configure/1","type":"function"},{"doc":"Check whether the ATECC508A has been configured or not. If this returns {:ok, false}, then configure/1 can be called.","ref":"NervesKey.Config.html#configured?/1","title":"NervesKey.Config.configured?/1","type":"function"},{"doc":"Helper for getting information about the ATECC module.","ref":"NervesKey.Config.html#device_info/1","title":"NervesKey.Config.device_info/1","type":"function"},{"doc":"Helper for getting the ATECC508A's serial number.","ref":"NervesKey.Config.html#device_sn/1","title":"NervesKey.Config.device_sn/1","type":"function"},{"doc":"This module handles Data Zone data stored in the NervesKey.","ref":"NervesKey.Data.html","title":"NervesKey.Data","type":"module"},{"doc":"Clear out the auxillary slots","ref":"NervesKey.Data.html#clear_aux_certs/1","title":"NervesKey.Data.clear_aux_certs/1","type":"function"},{"doc":"Return the slot that stores the compressed device certificate.","ref":"NervesKey.Data.html#device_cert_slot/1","title":"NervesKey.Data.device_cert_slot/1","type":"function"},{"doc":"Create a public/private key pair The public key is returned on success. This can only be called on devices that have their configuration locked, but not their data.","ref":"NervesKey.Data.html#genkey/2","title":"NervesKey.Data.genkey/2","type":"function"},{"doc":"Run the genkey operation on the NervesKey private key slot","ref":"NervesKey.Data.html#genkey_raw/2","title":"NervesKey.Data.genkey_raw/2","type":"function"},{"doc":"","ref":"NervesKey.Data.html#lock/3","title":"NervesKey.Data.lock/3","type":"function"},{"doc":"Return the slot that stores the compressed signer certificate.","ref":"NervesKey.Data.html#signer_cert_slot/1","title":"NervesKey.Data.signer_cert_slot/1","type":"function"},{"doc":"Return the slot that stores the signer's public key.","ref":"NervesKey.Data.html#signer_pubkey_slot/1","title":"NervesKey.Data.signer_pubkey_slot/1","type":"function"},{"doc":"Determine what's in all of the data slots","ref":"NervesKey.Data.html#slot_data/3","title":"NervesKey.Data.slot_data/3","type":"function"},{"doc":"Write new device and signer certificates to the auxillary slots","ref":"NervesKey.Data.html#write_aux_certs/4","title":"NervesKey.Data.write_aux_certs/4","type":"function"},{"doc":"Write all of the slots","ref":"NervesKey.Data.html#write_slots/2","title":"NervesKey.Data.write_slots/2","type":"function"},{"doc":"This module handles OTP data stored in the NervesKey.","ref":"NervesKey.OTP.html","title":"NervesKey.OTP","type":"module"},{"doc":"Convert a raw configuration to a nice map.","ref":"NervesKey.OTP.html#from_raw/1","title":"NervesKey.OTP.from_raw/1","type":"function"},{"doc":"Convert a raw configuration to a nice map. Raise if there is an error.","ref":"NervesKey.OTP.html#from_raw!/1","title":"NervesKey.OTP.from_raw!/1","type":"function"},{"doc":"Create a NervesKey OTP data struct","ref":"NervesKey.OTP.html#new/3","title":"NervesKey.OTP.new/3","type":"function"},{"doc":"Read NervesKey information from the OTP data.","ref":"NervesKey.OTP.html#read/1","title":"NervesKey.OTP.read/1","type":"function"},{"doc":"Convert a nice config map back to a raw configuration","ref":"NervesKey.OTP.html#to_raw/1","title":"NervesKey.OTP.to_raw/1","type":"function"},{"doc":"Write NervesKey information to the OTP zone.","ref":"NervesKey.OTP.html#write/2","title":"NervesKey.OTP.write/2","type":"function"},{"doc":"","ref":"NervesKey.OTP.html#t:raw/0","title":"NervesKey.OTP.raw/0","type":"type"},{"doc":"","ref":"NervesKey.OTP.html#t:t/0","title":"NervesKey.OTP.t/0","type":"type"},{"doc":"","ref":"NervesKey.ProvisioningInfo.html","title":"NervesKey.ProvisioningInfo","type":"module"},{"doc":"","ref":"NervesKey.ProvisioningInfo.html#t:t/0","title":"NervesKey.ProvisioningInfo.t/0","type":"type"},{"doc":"The NervesKey is a configured ATECC508A or ATECC608A Crypto Authentication chip that's used for authenticating devices with NervesHub and other cloud services. At a high level, it is a simple hardware security module (HSM) that protects one private key by requiring all operations on that key to occur inside chip. The project provides access to the chip from Elixir and makes configuration decisions to make working with the device easier. It has the following features: Provision blank ATECC508A/608A devices - this includes private key generation Storage for serial number and one-time calibration data (useful if primary storage is on a removable MicroSD card) Support for Microchip's compressed X.509 certificate format to work with Microchip's C libraries Support for signing device certificates so that devices can be included in a PKI Support for storing a small amount of run-time configuration in unused data EEPROM slots Support auxillary device/signer certificate storage to support pre-production experimentation without needing to lock down certificates It cannot be stressed enough that the NervesKey library locks down the ATECC508A/608A during the provisioning process. This is a feature and is required for normal operation, but if you're getting started, make sure that you have a few extra parts just in case you make a mistake. See NervesHub documentation for end-user NervesKey and NervesHub documentation. See hw/hw.md for hardware information or go to Tindie/NervesKey for a prebuilt-one. There are a few options for purchase as breakout boards with STEMMA QT / Qwiic 4-Pin JST SH connectors Adafruit ATECC608 - https://www.adafruit.com/product/4314 Sparkfun ATECC508A - https://www.sparkfun.com/products/15573 Sparkfun ATECC608A - https://www.sparkfun.com/products/15838","ref":"readme.html","title":"NervesKey","type":"extras"},{"doc":"The package can be installed by adding nerves_key to your list of dependencies in mix.exs : def deps do [ { :nerves_key , &quot;~&gt; 0.5&quot; } ] end The docs can be found at https://hexdocs.pm/nerves_key .","ref":"readme.html#installation","title":"NervesKey - Installation","type":"extras"},{"doc":"NervesKeys need to be provisioned before they can be used. That's a one-time step that could already have been done for you. If not, see subsequent sections for how that works. To use any of the NervesKey APIs, you will need a &quot;transport&quot; to communicate with the ATECC508A/608A that's doing all of the work. Currently the only supported transport is I2C. The following line would be run on your Nerves device (like a Raspberry Pi, BeagleBone or your own custom hardware): iex&gt; { :ok , i2c } = ATECC508A.Transport.I2C . init ( [ ] ) Check if your NervesKey has been provisioned: iex&gt; NervesKey . provisioned? ( i2c ) true If you get false , go to the provisioning sections. If you received an error, check that the NervesKey has a good connection to your hardware. If you have a custom board, you may need to pass parameters to ATECC508A.Transport.I2C.init/1 to set the correct I2C bus. NervesKeys are provisioned with serial numbers. In production, these can be of your choosing. iex&gt; NervesKey . manufacturer_sn ( i2c ) &quot;ABC12345&quot; Of course, the more interesting part of the NervesKeys are its storage of device private keys and their certificates. For the common case, it stores two X.509 certificates: one for the device and one for the certificate that signed the device certificate. The signer certificate is usually uploaded to the servers that the device will connect to so that it can authenticate the device. Here's how to get both of the certificates: iex&gt; NervesKey . device_cert ( i2c ) { :OTPCertificate , ... } # Put this in a convenient form: iex&gt; X509.Certificate . to_pem ( v ( ) ) |&gt; IO . puts -- -- - BEGIN CERTIFICATE -- -- - stuff stuff stuff -- -- - END CERTIFICATE -- -- - iex&gt; NervesKey . signer_cert ( i2c ) { :OTPCertificate , ... } The next step is to tell Erlang's SSL library that you want to use the NervesKey when connecting to the server. For that, you'll need nerves_key_pkcs11 which is included as a dependency of this library. This code is somewhat tedious but hopefully the following code fragment will help: { :ok , engine } = NervesKey.PKCS11 . load_engine ( ) { :ok , i2c } = ATECC508A.Transport.I2C . init ( [ ] ) signer_cert = X509.Certificate . to_der ( NervesKey . signer_cert ( i2c ) ) cert = X509.Certificate . to_der ( NervesKey . device_cert ( i2c ) ) key = NervesKey.PKCS11 . private_key ( engine , { :i2c , 1 } ) cacerts = [ signer_cert ] ++ Keyword . get ( opts , :trusted_certs , [ ] ) Tortoise.Supervisor . start_child ( server : { Tortoise.Transport.SSL , verify : :verify_peer , host : Keyword . get ( opts , :host ) , cert : cert , key : key , cacerts : cacerts , versions : [ :&quot;tlsv1.2&quot; ] , } ) Connecting to Google Cloud Platform IoT Core While the prior Tortoise code snippet works well with services like AWS, Google Cloud Platform (GCP) requires that a device must create a JWT token in order to connect to the broker . NervesKey provides the NervesKey.sign_digest function to assist with the JWT signature portion of Google's documentation. The following code fragment can help with creating the JWT that is required as the MQTT password: @doc &quot;&quot;&quot; Generate a JSON Web Token used to sign into the Google Cloud Platform IoT Core MQTT broker. &quot;&quot;&quot; @spec generate_jwt ( ) :: String . t ( ) def generate_jwt do jwt_expiration_in_hours = 4 iat = System . os_time ( :second ) exp = iat + jwt_expiration_in_hours * 60 * 60 aud = Application . get_env ( :__my_project__ , :gcp_project_id ) header = %{ &quot;alg&quot; =&gt; &quot;ES256&quot; , &quot;typ&quot; =&gt; &quot;JWT&quot; } payload = %{ &quot;iat&quot; =&gt; iat , &quot;exp&quot; =&gt; exp , &quot;aud&quot; =&gt; aud } sign ( header , payload ) end @doc &quot;&quot;&quot; Sign a JSON Web Token. &quot;&quot;&quot; @spec sign ( header :: map , payload :: map ) :: String . t ( ) def sign ( header , payload ) do { :ok , transport } = ATECC508A.Transport.I2C . init ( [ ] ) encoded_header = header |&gt; Jason . encode! ( ) |&gt; Base . url_encode64 ( padding : false ) encoded_payload = payload |&gt; Jason . encode! ( ) |&gt; Base . url_encode64 ( padding : false ) digest = :crypto . hash ( :sha256 , &quot; \#{ encoded_header } . \#{ encoded_payload } &quot; ) { :ok , signature } = NervesKey . sign_digest ( transport , digest ) encoded_signature = Base . url_encode64 ( signature , padding : false ) &quot; \#{ encoded_header } . \#{ encoded_payload } . \#{ encoded_signature } &quot; end This fragment can allow for the dependency injection of sign if the firmware needs to run both with and without the ATECC crypto chip (i.e. on the target and on the host). JOSE.JWT.sign can be used for a host implementation.","ref":"readme.html#general-use","title":"NervesKey - General use","type":"extras"},{"doc":"The ATECC508A/608A in the NervesKey needs to be provisioned before it can be used. Before you can do that, you'll need the following: A signer certificate and its private certificate (in other contexts, this is called a certificate authority) A serial number for your device A name for the device The signer certificate and serial number are very important. After the provisioning process, they are locked down and cannot be changed without replacing the ATECC508A/608A. The device name is purely informational unless you choose to use it in your software. NervesKeys support an auxillary set of certificates that identify the device. These are writable after the provisioning process. Since they're writable, they can be provisioned and updated at any time. As such, they're not programmed in the first-time provisioning process. Signer certificates Part of the provisioning process creates an X.509 certificate for the NervesKey that can be used to authenticate TLS connections. This certificate is signed by a &quot;signer certificate&quot;. You will eventually need to upload the signer certificate to NervesHub or AWS IoT or wherever you would like to authenticate devices. Due to memory limitations, the ATECC508A/608A has a way to compress X.509 certificates on chip. See ATECC Compressed Certificate Definition . To comply with the limitations of compressible certificates, NervesKey provides a mix task to create them: $ mix nerves_key.signer create nerveskey_prod_signer1 Created signer cert, nerveskey_prod_signer1.cert and private key, nerveskey_prod_signer1.key. Please store nerveskey_prod_signer1.key in a safe place. nerveskey_prod_signer1.cert is ready to be uploaded to the servers that need to authenticate devices signed by the private key. There is no magic in the compressible certificates. They're just limited in what they can contain. You can inspect them with openssl x509 -in nerveskey_prod_signer1.cert -text . Check with your IoT service on how the signer certificate is used. If it's only used for first-time device registration, then the signer certificate may not need a long expiration time. You may also be interested in creating more than one signer certificate if you have more than one manufacturing facility. Manufacturer serial numbers Be aware that there are a lot of things called serial numbers. In an attempt to minimize confusion, we'll refer to the serial number that identifies the device to humans and other machines as the &quot;manufacturer serial number&quot;. This string (it need not be a number) is commonly printed on a label on a device. It may be embedded in a barcode. Other serial numbers exist - the ATECC508A/608A has a 9 byte one and X.509 certificates have ones. Those serial numbers have guarantees on uniqueness. It is up to the device manufacturer to make sure that the &quot;manufacturer serial number&quot; is unique. People generally want to do this for their own sanity. The NervesKey saves the manufacturing serial number in the one-time programmable memory on the ATECC508A/608A and also in the device's X.509 certificate. The device's X.509 certificate is signed, so cloud servers can trust the manufacturer serial number. At this point, you're the manufacturer. Decide how you'd like your serial numbers to look. Whatever you pick, it must fit in 48-bytes. Representing the serial number is ASCII is commonly done. If you don't want to deal with this, do what we do (Base32-encode the ATECC508A/608A's globally unique identifier): iex&gt; { :ok , i2c } = ATECC508A.Transport.I2C . init ( [ ] ) { :ok , { ATECC508A.Transport.I2C , { # Reference &lt; 0.879310498 . 269090821.27261 &gt; , 96 } } } iex&gt; NervesKey . default_info ( i2c ) % NervesKey.ProvisioningInfo { board_name : &quot;NervesKey&quot; , manufacturer_sn : &quot;AER245UNQOY4T3Q&quot; }","ref":"readme.html#preparing-for-provisioning","title":"NervesKey - Preparing for provisioning","type":"extras"},{"doc":"Now that you have a signer certificate, the signer's private key, and a manufacturer serial number, you can provision a NervesKey or the ATECC508A/608A acting as a NervesKey in your device. Usually there's some custom manufacturing support software that performs this step. We'll provision at the iex prompt. Use sftp to copy the signer certificate and private key to your device. We'll put them /tmp so that they disappear on reboot: $ sftp nerves.local Connected to nerves.local. sftp&gt; cd /tmp sftp&gt; put nerveskey_prod_signer1.* Uploading nerveskey_prod_signer1.cert to /tmp/nerveskey_prod_signer1.cert nerveskey_prod_signer1.cert 100% 636 78.3KB/s 00:00 Uploading nerveskey_prod_signer1.key to /tmp/nerveskey_prod_signer1.key nerveskey_prod_signer1.key 100% 228 78.3KB/s 00:00 sftp&gt; exit Next, go to the IEx prompt on the device and run the following: # Customize these or use `NervesKey.default_info/1` for defaults cert_name = &quot;nerveskey_prod_signer1&quot; manufacturer_sn = &quot;N1234&quot; board_name = &quot;NervesKey&quot; # These lines should be copy/paste signer_cert = File . read! ( &quot;/tmp/ \#{ cert_name } .cert&quot; ) |&gt; X509.Certificate . from_pem! ; true signer_key = File . read! ( &quot;/tmp/ \#{ cert_name } .key&quot; ) |&gt; X509.PrivateKey . from_pem! ( ) ; true { :ok , i2c } = ATECC508A.Transport.I2C . init ( [ ] ) provision_info = % NervesKey.ProvisioningInfo { manufacturer_sn : manufacturer_sn , board_name : board_name } # Double-check what you typed above before running this NervesKey . provision ( i2c , provision_info , signer_cert , signer_key ) If the last line returns :ok after about 2 seconds, then celebrate. You successfully programmed a NervesKey. You can't program it again. If you try, you'll get an error.","ref":"readme.html#provisioning","title":"NervesKey - Provisioning","type":"extras"},{"doc":"If a situation arises where the originally provisioned certificate can't be used, it's possible to store a second certificate on the device. This second certificate uses the same private key as the first certificate. (It is assumed that the algorithmic and physical protections on the first private key are sufficient that storing two different private keys doesn't add value.) Use cases include: Recovering from expiration or loss of the original signer key Experimentation Fixing errors in the original certificates The auxiliary certificate is stored in writable memory on the ATECC508A/608A. The NervesKey must be provisioned before the auxiliary certificate can be written. Assuming that's been done, copy the signer certificate and private key to your device similar to what you did before. Then run the following at the IEx prompt: # Customize these cert_name = &quot;nerveskey_prod_signer1&quot; # These lines should be copy/paste signer_cert = File . read! ( &quot;/tmp/ \#{ cert_name } .cert&quot; ) |&gt; X509.Certificate . from_pem! ; true signer_key = File . read! ( &quot;/tmp/ \#{ cert_name } .key&quot; ) |&gt; X509.PrivateKey . from_pem! ( ) ; true { :ok , i2c } = ATECC508A.Transport.I2C . init ( [ ] ) NervesKey . provision_aux_certificates ( i2c , signer_cert , signer_key )","ref":"readme.html#provisioning-an-auxiliary-certificate","title":"NervesKey - Provisioning an auxiliary certificate","type":"extras"},{"doc":"Before hardware is available or if you're debugging connections to a service (like AWS IoT) and having no luck, it can be useful to manually generate device certificates. The nerves_key.device helper can be used for this and does not require a NervesKey at all. Certificates generated using this helper will look like ones stored on the NervesKey except for the important feature of the private key part being private. Here's an example: mix nerves_key.device create &lt;serial number&gt; --signer-cert ca.cert --signer-key ca.key Just like the signer certs, you can inspect the generated certs with openssl x509 . Services that work with these certificates should work with real NervesKeys.","ref":"readme.html#debugging-without-an-atecc508a-608a","title":"NervesKey - Debugging without an ATECC508A/608A","type":"extras"},{"doc":"The NervesKey has bytes left over for storing a few settings. The NervesKey.put_settings/2 and NervesKey.get_settings/1 APIs let you store and retrieve a map. Since the storage is limited and relatively slow, this is intended for settings that rarely change or may be tightly coupled with certificates already being stored in the NervesKey. Internally, NervesKey calls :erlang.term_to_binary to convert the map to raw bytes and then it spreads it across ATECC508A slots for storage. This means that the keys used in the map take up space too.","ref":"readme.html#settings","title":"NervesKey - Settings","type":"extras"},{"doc":"If you run into problems, please help us improve this project by filing an issue .","ref":"readme.html#support","title":"NervesKey - Support","type":"extras"},{"doc":"This section describes the ATECC508A/608A configuration used for the NervesKey . This information isn't needed for using the library. See Table 2-5 in the ATECC508A data sheet for documentation on the configuration zone. This software expects the following configuration to be programmed (unspecified bytes are either not programmable or kept as their defaults): Bytes Name Value Description 14 I2C_Enable 01 I2C mode 16 I2C_Address C0 I2C address of the module (default) 18 OTPmode AA OTP is in read-only mode 19 ChipMode 00 Default mode 20-51 SlotConfig N/A See the next table 92-95 X509Format 00..00 Unused 96-127 KeyConfig N/A See next table The slots are programmed as follows. This definition is organized to be similar to the Microchip Standard TLS Configuration to minimize changes to other software. Unused slots are configured so that applications can use them as they would an EEPROM. Slot Description SlotConfig KeyConfig Primary properties 0 Device private key 87 20 33 00 Private key, read only; lockable 1 Unused 0F 0F 1C 00 Clear read/write; not lockable 2 Unused 0F 0F 1C 00 Clear read/write; not lockable 3 Unused 0F 0F 1C 00 Clear read/write; not lockable 4 Unused 0F 0F 1C 00 Clear read/write; not lockable 5 Settings (Part 3) 0F 0F 1C 00 Clear read/write; not lockable 6 Settings (Part 2) 0F 0F 1C 00 Clear read/write; not lockable 7 Settings (Part 1) 0F 0F 1C 00 Clear read/write; not lockable 8 Settings (Part 0) 0F 0F 3C 00 Clear read/write; lockable 9 Aux device certificate 0F 0F 3C 00 Clear read/write; lockable 10 Device certificate 0F 2F 3C 00 Clear read only; lockable 11 Signer public key 0F 2F 30 00 P256; Clear read only; lockable 12 Signer certificate 0F 2F 3C 00 Clear read only; lockable 13 Signer serial number + 0F 2F 3C 00 Clear read only; lockable 14 Aux signer public key 0F 0F 3C 00 Clear read/write; lockable 15 Aux signer certificate 0F 0F 3C 00 Clear read/write; lockable The signer serial number slot is currently unused since the signer's cert is computed from the public key The ATECC508A includes a 64 byte OTP (one-time programmable) memory. It has the following layout: Bytes Name Contents 0-3 Magic 4e 72 76 73 4 Flags_MSB 0 5 Flags_LSB 0 = 16 byte serial number, 1 = 32 byte serial number 6-15 Board name 10 byte name for the board in ASCII (set unused bytes to 0) 16-31 Mfg serial number Serial number in ASCII (set unused bytes to 0) 32-63 Serial# or User If Flags == 1, then the rest of the serial number","ref":"readme.html#atecc508a-configuration","title":"NervesKey - ATECC508A configuration","type":"extras"},{"doc":"The NervesKey is a tiny circuit board with an ATECC608A cryptographic chip from Microchip Technology . It is an inexpensive addition to the Raspberry Pi and other embedded computing platforms that include an I2C bus. The production NervesKey board contains the tiny 'UDFN' version of the part ATECC608A-MAHDA and a 0.1uF 0402 size capacitor. These boards are not easily assembled, so they are professionally manufactured in high quantity for the Nerves project and offered for sale at Tindie / NervesKey .","ref":"hw.html","title":"Hardware","type":"extras"},{"doc":"The easiest way to outfit a Raspberry Pi with a NervesKey is to solder it to the 'hat' expansion header on the bottom of the board as shown below. This will connect the appropriate signals and keep the board out of the way of other uses of the hat header. The NervesKey board is thin to support this application.","ref":"hw.html#mounting-to-a-raspberry-pi","title":"Hardware - Mounting to a Raspberry Pi","type":"extras"},{"doc":"See the schematic for additional hardware details, notes, and examples.","ref":"hw.html#schematics","title":"Hardware - Schematics","type":"extras"},{"doc":"Microchip's ATECC508A website Microchip's ATECC608A website cryptoauthlib - a different, but official C library for the ATECC508A/608A","ref":"hw.html#links","title":"Hardware - Links","type":"extras"}]